/*
 * This is a GENERATED FILE -- do not edit.
 * See known-functions.csv and buildtools/src/ParseFunctions.java
 */
/**
 * @file unity.h
 */

#include <stdio.h>              /* for NULL */
#include <stdlib.h>             /* for bsearch */
#include <string.h>             /* for strcmp */
#include <assert.h>

#define UNITY_INTERNAL 1
#include "function-definitions.h"
#include "known-syntaxes.h"

const FunctionDef function_definitions[] = {
  { "Common Logarithm (base 10)", "\\log" },
  { "Natural Logarithm", "\\ln" },
  { "Exponential", "\\exp" },
  { "Square root", "\\sqrt" },
  { "Sine", "\\sin" },
  { "Cosine", "\\cos" },
  { "Tangent", "\\tan" },
  { "Arc sine", "\\arcsin" },
  { "Arc cosine", "\\arccos" },
  { "Arc tangent", "\\arctan" },
  { "Hyperbolic sine", "\\sinh" },
  { "Hyperbolic cosine", "\\cosh" },
  { "Hyperbolic tangent", "\\tanh" },
};
const size_t n_function_definitions = sizeof(function_definitions)/sizeof(function_definitions[0]);

typedef struct { const char* abbrev; int idx; } StxMap;
/* Verify that the syntax name indexes match */
#if UNITY_SYNTAX_FITS != 0
#  error "UNITY_SYNTAX_FITS must equal 0"
#endif
StxMap stx_0[] = { // syntax for UNITY_SYNTAX_FITS
  { "exp", 2},
  { "ln", 1},
  { "log", 0},
  { "sqrt", 3},
};
#if UNITY_SYNTAX_OGIP != 1
#  error "UNITY_SYNTAX_OGIP must equal 1"
#endif
StxMap stx_1[] = { // syntax for UNITY_SYNTAX_OGIP
  { "acos", 8},
  { "asin", 7},
  { "atan", 9},
  { "cos", 5},
  { "cosh", 11},
  { "exp", 2},
  { "ln", 1},
  { "log", 0},
  { "sin", 4},
  { "sinh", 10},
  { "sqrt", 3},
  { "tan", 6},
  { "tanh", 12},
};
#if UNITY_SYNTAX_CDS != 2
#  error "UNITY_SYNTAX_CDS must equal 2"
#endif
StxMap stx_2[] = { // syntax for UNITY_SYNTAX_CDS
};
#if UNITY_SYNTAX_VOUNITS != 3
#  error "UNITY_SYNTAX_VOUNITS must equal 3"
#endif
StxMap stx_3[] = { // syntax for UNITY_SYNTAX_VOUNITS
  { "exp", 2},
  { "ln", 1},
  { "log", 0},
  { "sqrt", 3},
};

typedef struct { StxMap* m; size_t len; } syntax_table_entry;
syntax_table_entry stxmaps[] = { 
  { stx_0, 4 }, // fits
  { stx_1, 13 }, // ogip
  { stx_2, 0 }, // cds
  { stx_3, 4 }, // vounits
};
const int n_stxmaps = sizeof(stxmaps)/sizeof(stxmaps[0]);

static int stxmap_compare(const void* key, const void* test)
{
    return strcmp((char*)key, ((StxMap*)test)->abbrev);
}

/**
 * Retrieves a function definition object.
 * Returns NULL if the abbreviation is not recognised in
 * the indicated syntax (or if the syntax is invalid).
 * @param abbrev a function abbreviation, for example "log" for Common Logarithm
 * @param syntax one of the UNITY_SYNTAX_* constants
 * @return a pointer to a function definitions string, or NULL if none such exists in this syntax
 */
const FunctionDef* unity_get_function(const char* abbrev, const int syntax)
{
    const StxMap* stxmap_found;
    
    if (syntax < 0 || syntax >= n_stxmaps) {
        return NULL;
    }
    
    stxmap_found = (StxMap*)bsearch(abbrev,
                                    stxmaps[syntax].m,
                                    stxmaps[syntax].len,
                                    sizeof(StxMap),
                                    stxmap_compare);
    if (stxmap_found == NULL) {
        return NULL;
    } else {
        assert(stxmap_found->idx >= 0
               && stxmap_found->idx < n_function_definitions);
        return &function_definitions[stxmap_found->idx];
    }
}

/* Inverse function: given a function definition, return its abbreviation,
   or NULL */
const char* unity_get_function_abbreviation(const FunctionDef* def,
                                            const int syntax)
{
    const StxMap* map;
    int i;

    if (syntax < 0 || syntax >= n_stxmaps) {
        return NULL;
    }

    map = stxmaps[syntax].m;
    for (i=0; i<stxmaps[syntax].len; i++) {
        // compare pointers
        if (def == &function_definitions[map[i].idx]) {
            return map[i].abbrev; /* JUMP OUT */
        }
    }
    return NULL;
}

