#ifndef FUNCTION_DEFINITIONS_H
#define FUNCTION_DEFINITIONS_H 1

#include "unitylib.h"

/* The functions exported by this module are the only ones which need
 * access to the data structures dumped into this file, which are
 * potentially subject to change.  The implementation of this header
 * file is generated by ../grammar/ParseFunctions.java, using the
 * function-definitions.c.template file in that directory.
 *
 * The structure elements with leading underscores are intended to be internal to
 * this function-definition.c module.
 */

struct function_definition {
    const char* description;
    const char* latex_form; 
};
typedef struct function_definition FunctionDef;

const FunctionDef* unity_get_function(const char* abbrev, const int syntax);
const char* unity_get_function_abbreviation(const FunctionDef* def,
                                            const int syntax);

#endif /* FUNCTION_DEFINITIONS_H */
