package uk.me.nxg.unity;

import java.util.List;

/**
 * The class representing the values parsed by the grammar.  
 *
 * <p>There is no type-safety managed by this class, since (a) the
 * fields are read and written directly by the generated grammar
 * classes, and (b) it's the grammar's responsibility to manage that
 * type safety (which it does, that being the point of it...).
 */
class UnitVal {
    static final char CHAR_DECA = (char)1;

    public int i;
    public double f;
    public String s;
    public OneUnit u;
    public List<OneUnit> uList;

    public UnitVal()             { } // parser includes a call to new UnitVal()
    public UnitVal(int v)        { i=v; }
    public UnitVal(String v)     { s=v; }
    public UnitVal(OneUnit v)    { u=v; }
    public UnitVal(double v)     { f=v; }
}
