package uk.me.nxg.unity;

class UnitWriterDebugging extends UnitWriter {

    java.text.DecimalFormat df;

    public UnitWriterDebugging(UnitExpr ue) {
        super(ue);
        // Force the formatting of numbers to be in the US locale (ie
        // we get '.' not ',' as the decimal separator); this makes
        // the test locale-independent.
        df = new java.text.DecimalFormat("#.###", new java.text.DecimalFormatSymbols(java.util.Locale.US));
    }

    public String write() {
        boolean first = true;
        StringBuilder sb = new StringBuilder();

        double lfact = ue.getLogFactor();
        if (lfact == Math.floor(lfact)) {            
            sb.append(String.format("%d", Math.round(ue.getLogFactor())));
        } else {
            sb.append(df.format(ue.getLogFactor()));
        }
        for (OneUnit u : ue) {
            sb.append(' ').append(u.toDebugString());
        }
        return sb.toString();
    }

    void writeNumber(StringBuilder sb, double d) {
        writeNumber(sb, d, false, false, false);
    }
}
